function love.load(arg)
if arg[#arg] == "-debug" then require("mobdebug").start() end

require("load_tiles")
require("load_buttons")
tile = {}
load_tiles()--loads the tile set
button = {}
bxo = 0
byo = 0
load_buttons()

--origin x and y points
ox = 400
oy = -400

--the tiles widths/heights (rectangle they are in)
tile_width = 128
tile_height = 64

--creating tile map
tile_set = {}
--creating time map
time_set = {}
--indexing from 1-20 (not zero but i might need to change that?)
for a=1,20,1 do
	tile_set[a] = {}
	time_set[a] = {}
	for b=1,20,1 do
		tile_set[a][b] = 10 + math.random(0,4)
		time_set[a][b] = -1--set all time to -1
	end
end

tile_set_size = 20--map size; ie, 4x4
day = 0--counting the number of day/night cycles
actions_given = 10--actions given per cycle
actions = actions_given--available actions
selector = 10--putting tile selector when clicking on an area
gold = 20--moneys
plant_cost = 0



text = ""--debugstuff
text2 =""

--setting mouse position coords to 0,0
ax = 0
by = 0
end
--

--#######################################################################

function love.update(dt)
if love.mouse.isDown('l') then
	x,y = love.mouse.getPosition()
	ox = x - mouse_distx--mouse dist from love.mousePressed
	oy = y - mouse_disty
end

end
--

--#######################################################################

function love.draw()
love.graphics.setColor(255, 255, 255, 255)--just for shits
love.graphics.print("Current FPS: "..tostring(love.timer.getFPS( )).."gold: "..gold.."actions: "..actions, 10, 10)

for a,b in ipairs(tile_set) do--for index,value...
  for c,d in ipairs(b) do--for index,value...
	e,f = convert_index(d)
	draw_tile(a,c,tile[e][f])
   end
end

ax,by = love.mouse.getPosition()--condense
ax,by = to_tile_position(ax,by)--mouse x,y on screen to the corresponding tile position
draw_tile(ax,by,tile_outline)--draw the tile_outline at tile ax,by




--temp side buttons
love.graphics.rectangle("fill",25,150,64,64)
love.graphics.rectangle("fill",25,250,64,64)
love.graphics.rectangle("fill",25,350,64,64)

--seeeed thing
if draw_seed_box then
  love.graphics.rectangle("fill", 128, 64, 597, 452)--proportionally correct
  draw_top = 2
  for a = 0,3,1 do
    for b=0, draw_top, 1 do
      draw_button(bxo+17+(a*145),byo+17+(b*145),button[a][b][0])--shitty ipairs index from 1-x
    end
  end
end
--


--for debugging change 'text' to whatever want to print
love.graphics.print(text,50,20,0,2,2)
love.graphics.print(text2,50,500,0,2,2)
end
--

--#######################################################################

function draw_tile(ax,by,tile)--draws tile tile at tile_set[ax][by]
love.graphics.draw(tile, ox+((ax-by)*(tile_width/2)),oy+((ax+by)*(tile_height/2))-(tile:getHeight()-64))--tile height needed for >64px tiles high
end
--

function draw_button(x,y,button)
  love.graphics.draw(button,x,y)
end
--

function convert_index(a)--converts two values to the index; 31 to 3,1
return (math.ceil(a/10-0.5)),(a%10)
end
--

--#######################################################################

function day_cycle()
actions = actions_given
for a,b in pairs(tile_set) do
	for c,d in pairs(b) do 
    e,f = convert_index(d)
    if (f) < 4 and (e) > 1 then
      tile_set[a][c] = tile_set[a][c]+1
      actions = actions_given
    end
	end
end
end
--


function to_tile_position(x,y)--converts x,y points to tile points
--dist from origin converted to tile position in tile_set rounding up
ax = math.floor((((x-ox-64)/(tile_width/2) + (y-oy-32)/(tile_height/2)) /2)+0.5)
by = math.floor((((y-oy-32)/(tile_height/2) - (x-ox-64)/(tile_width/2)) /2)+0.5)
if ax >= 1 and ax <= tile_set_size and by >= 1 and by <= tile_set_size then--checking bounds
  return ax,by--nearest tile position from mouse location(tile mouse is on)
else
  return 1,1--if out of bounds return 1,1
end
end
--


function love.mousepressed(x,y,button)
  if button == 'l' then
    mouse_startx = x--still need these 2, probs can remove later, check the mouse.released
    mouse_starty = y
    --this is required for the movement; see .update
    mouse_distx = x-ox--dist from ox
    mouse_disty = y-oy
	end
end
--

function seed_selection(x,y)--pls make pretty
  if x > bxo and y > byo and x < bxo+600 and y < byo+500 then
	zx = ((x-bxo)%145)/145
	zy = ((y-byo)%145)/145
    if zx <= 1 and zx >= 0.13 then
      if zy <= 1 and zy >= 0.13 then
        zx = math.ceil((x-bxo)/145)
        zy = math.ceil((y-byo)/145)
        text2 = "this is: "..zx.." and "..zy
        selector = ((2+zx)*10) + ((zy-1)*40)--temp solution right
        draw_seed_box = not draw_seed_box
        plant_cost = button[zx][zy][1]
        --plant_cost = 1 + plant_cost
        text = "selector is: "..selector.." and cost: "..plant_cost
      end
    end
  end
end
--

function love.mousereleased(x,y,button)
	if button == 'l' then
		if mouse_startx > x-5 and mouse_startx < x+5 then--maybe have a range of 5-10
			if mouse_starty > y-5 and mouse_starty < y+5 then
				if draw_seed_box then
					--seed selection
					seed_selection(x,y)
				else
				if x >= 89 then--not on the side menu part
					--need to check for action points use and stuff
					ax,by = to_tile_position(x,y)
					if (math.ceil(tile_set[ax][by]/10-0.5)) == 2 and actions > 0 and gold > 0 then--can plant on tilled earth
            --PROBLEM tilled earth being tilled costs moneys######################
            --gold isn't correct as each plant costs a different amount?
            tile_set[ax][by] = selector
            actions = actions-1
            gold = gold-plant_cost
          elseif math.ceil(selector/10-0.5) == 2 and actions > 0 then--can till any earth
            if tile_set[ax][by]%10 == 4 then 
              gold = gold +2
            end
            
            tile_set[ax][by] = selector
            actions = actions-1
          end
          --
          
				elseif y >= 150 then
          if y <= 214 then--first button
            day_cycle()
          elseif y > 250 and y <= 314 then--second button
            selector = 20
          elseif y > 350 and y<= 414 then--third button
            
            draw_seed_box = not draw_seed_box
          end
				end
        end
			end
		end	
	end
end
--
