local set = {}
local tile_width = 128
local tile_height = 64

function love.load()
  
  require("func/load_tiles")
  require("func/load_buttons")
  require("func/import_file")
  require("func/load_stockpile")
  require("func/load_menu")
  set_vars()
  load_tiles()
  load_buttons()
  load_stockpile()
  load_menu()







end
--



function love.update(dt)
  
  text = "selector: "..selector.."\nTime till market change: "..(30-market_time).."\nDelivery Time: "..travel_time.." fps: "..love.timer.getFPS()
  resources_text = "GOLD: "..gold
  inc_second(dt)
  mouse_down()
  
end
--



function love.draw()
  
  draw_tiles(tile_width, tile_height)
  draw_menu_buttons()
  draw_seed_box()
  
  love.graphics.print(text,20,20)
  love.graphics.print(resources_text, 300, 20, 0, 3)
  
  asx,ady = love.mouse.getPosition()
  if selector == -1 then
    love.graphics.print("   "..table.getn(basket),asx,ady)
  end
  
end
--


--setvars
function set_vars()
  

  --origin x and y points
  ox = 400
  oy = -400
  --setting mouse position coords to 0,0
  ax = 0
  by = 0
  --time stuff
  second = 0
  seed_box = false
  selector = 20
  gold = 20
  stock = 0
  
  cx = 0
  basket = {0}
  b2 = {}
  market_time = 0
  travel_time = 10
  sent_order = false
  
  plant_time = {}
  plant_cost = {}
  import_data("data/plant_time.txt",plant_time)
  import_data("data/plant_cost.txt",plant_cost)
  plant_value = copy(plant_cost)--plant value and cost are different hehe
  set_size = 20
  
  load_set(set_size)--set size of 20
  
  resources_text = "GOLD: "..gold
  
end
--




function load_set(set_size)
math.randomseed(os.time())
--set = {}
for a=1,set_size,1 do
	set[a] = {}
	for b=1,set_size,1 do
		set[a][b] = {[0]=(10 + math.random(0,4)), [1] = -1}--time needs fixing??
	end
end

end
--



function inc_second(dt)
  
second = second + dt
if second >= 0.5 then
  second = second - 0.5
  time_check()
end
  
end
--





function time_check()
  
for a=1,set_size,1 do
	for b=1,set_size,1 do
		if set[a][b][1]-1 == -1 then
      local tx,ty = convert_index(set[a][b][0])--innefficient can just %10?
      if tx > 2 and ty < 4 then
        set[a][b][0] = set[a][b][0] + 1
        set[a][b][1] = plant_time[tx]
      end
    else
      set[a][b][1] = set[a][b][1] - 0.5
    end
	end
end
market_time = market_time + 0.5
if market_time >= 30 then
  market_time = market_time - 30
  price_rand()
end
if sent_order then
    travel_time = travel_time - 0.5
    if travel_time <= 0 then 
      sell(b2)
    end
  end
end
--



function mouse_down()
  
  if love.mouse.isDown('l') then
    x,y = love.mouse.getPosition()
    ox = x - mouse_distx--mouse dist from love.mousePressed
    oy = y - mouse_disty
  end
  
end
--



function draw_tiles()
  
function draw_tile(ax,by,tile)--draws tile tile at tile_set[ax][by]
love.graphics.draw(tile, ox+((ax-by)*(tile_width/2)),oy+((ax+by)*(tile_height/2))-(tile:getHeight()-64))
end
--
for a,b in ipairs(set) do--for index,value...
  for c,d in ipairs(b) do--for index,value...
    e,f = convert_index(d[0])
    draw_tile(a,c,tile[e][f])
   end
end
--outline
local ax,by = to_tile_position(love.mouse.getPosition())--mouse x,y on screen to the corresponding tile position
draw_tile(ax,by,tile_outline)--draw the tile_outline at tile ax,by

end
--






function draw_menu_buttons()
  
for aa = 1,5,1 do
  draw_button(25,aa*100+50,menu_buttons[aa])
end
end
--



function draw_button(x,y,button)
  love.graphics.draw(button,x,y)
end
--



function draw_seed_box()
  
if seed_box then
  love.graphics.rectangle("fill", 128, 64, 597, 452)--proportionally correct weirdly enough
  local draw_top = 2
  for a = 0,3,1 do
    for b=0, draw_top, 1 do
      draw_button(bxo+17+(a*145),byo+17+(b*145),button[a][b][0])
      if b < 1 then 
        love.graphics.print(" Price: "..plant_cost[3+a].."   Value: "..plant_value[3+a],a*145+145, b*145+85)
      end
    end
  end
end
--
end
--



function to_tile_position(x,y)--converts x,y points to tile points
--dist from origin converted to tile position in tile_set rounding up
ax = math.floor((((x-ox-64)/(tile_width/2) + (y-oy-32)/(tile_height/2)) /2)+0.5)
by = math.floor((((y-oy-32)/(tile_height/2) - (x-ox-64)/(tile_width/2)) /2)+0.5)
if ax >= 1 and ax <= set_size and by >= 1 and by <= set_size then--checking bounds
  return ax,by--nearest tile position from mouse location(tile mouse is on)
else
  return 1,1--if out of bounds return 1,1
end
end
--



function convert_index(a)--converts two values to the index; 31 to 3,1
return (math.ceil(a/10-0.5)),(a%10)
end
--



function seed_selection(x,y)--pls make pretty
if x > bxo and y > byo and x < bxo+600 and y < byo+500 then
	zx = ((x-bxo)%145)/145
	zy = ((y-byo)%145)/145
    if zx <= 1 and zx >= 0.13 then
      if zy <= 1 and zy >= 0.13 then
        zx = math.ceil((x-bxo)/145)
        zy = math.ceil((y-byo)/145)
        selector = ((2+zx)*10) + ((zy-1)*40)
        seed_box = not seed_box
      end
    end
  end
end
--




function love.mousepressed(x,y,button)
  if button == 'l' then
    mouse_startx = x--still need these 2, probs can remove later, check the mouse.released
    mouse_starty = y
    --this is required for the movement; see .update
    mouse_distx = x-ox--dist from ox
    mouse_disty = y-oy
	end
end
--





function place_stock_pile()
  
  stock_pile[""..ax..by] = {}
  --stock_pile_size = stock_pile_size + 10
  set[ax][by][0] = 70
  --set[ax][by][1] = -1
  gold = gold - plant_cost[7]
  
end
--


function fruit_collection()
  --fruit -> basket
  if (table.getn(basket))+1 <= 10 then
    table.insert(basket, set[ax][by][0])
    set[ax][by][0] = 10 + math.random(0,4)
  end
  
end
--

function stock_pile_selection()
  
  if table.getn(basket) > 0 then
    
    while table.getn(basket) > 0 and table.getn(stock_pile[""..ax..by]) < 10 do
      --basket -> stockpile
      table.insert(stock_pile[""..ax..by],table.remove(basket))
      if set[ax][by][0]%10 < 4 then
        set[ax][by][0] = set[ax][by][0] + 1
      end
    end
    
  else--basket is emtpy
    while table.getn(basket) < 10 and table.getn(stock_pile[""..ax..by]) > 0 do
      --stockpile -> basket
      table.insert(basket, table.remove(stock_pile[""..ax..by]))
      if set[ax][by][0]%10 > 0 then
        set[ax][by][0] = set[ax][by][0] - 1
      end
    end
    
  end
  
end
--


--git thing
function copy (t) -- shallow-copy a table
    if type(t) ~= "table" then return t end
    local target = {}
    for k, v in pairs(t) do target[k] = v end
    return target
end
--

function sell(l)--selling a load of thingamies
    local count = 1
    local n = 2
    local z = {}
    table.sort(l)
    gold = gold + plant_value[math.floor(l[1]/10)]
    local size = table.getn(l)
  
    while n <= table.getn(l) do
      gold = gold + plant_value[math.floor(l[n]/10)]
      if l[n-1] ~= l[n] then
        z[math.floor(l[n-1]/10)] = count
        count = 1
      else
        count = count + 1
      end
      n=n+1
    end
    z[math.floor(l[n-1]/10)] = count
    --iterate through the plant list and increase/decrease the prices of it all depending on nubmer of items in list l
    for a,b in ipairs(plant_value) do
      plant_value[a] = plant_value[a] + size
    end
    for a,b in pairs(z) do
      if plant_value[a] - 2*b < 0 then
        plant_value[a] = 0
      else
        plant_value[a] = plant_value[a] - 2*b
      end
    end
    travel_time = 10
    sent_order = false
    b2 = {}
end
--



function price_rand()
  
  math.randomseed(os.time())
  for a,b in pairs(plant_cost) do
    --a index, b item
    r1 = math.random(-5, 5)
    r2 = math.random(-5, 5)
    if plant_value[a]+0 > b+0 then--need to compress this shit
      if( plant_value[a] + r1) - b < (plant_value[a] + r2) - b then
        plant_value[a] = plant_value[a] + r1
      else
        plant_value[a] = plant_value[a] + r2
      end
    else
      if( plant_value[a] + r1) - b > (plant_value[a] + r2) - b then
        plant_value[a] = plant_value[a] + r1
      else
        plant_value[a] = plant_value[a] + r2
      end
    end
    
    
  end
end
--

function love.mousereleased(x,y,button)
  
  function menu_selection(x,y)
    
    if y >= 150 and y <= 214 then--first button
      selector = -1--makes selector the 'picking' selector
      basket = {}
    elseif y > 250 and y <= 314 then--second button
      selector = 20
    elseif y > 350 and y <= 414 then--third button
      seed_box = not seed_box
    elseif y > 450 and y < 514 then--fourth button
      if selector == -1 and table.getn(basket) >= 2 and not sent_order then
        --sent_order = true
        b2 = {}
        b2 = copy(basket)
        basket = {}
      end
    elseif y > 550 and y < 614 then--fifth button
      if table.getn(b2) >= 2 and not sent_order then
        sent_order = true
      end
    end
    
  end
  
function board_action(x,y)
  
  ax,by = to_tile_position(x,y)
  cx,dy = convert_index(set[ax][by][0])--problem is from when using selector -1 and calculating gold value

  if selector == 20 then--can till any earth
    set[ax][by][0] = selector
   
  elseif selector == 70 then--is a stockpile thing
    if gold-plant_cost[7] > 0 then 
      place_stock_pile()
    end
   
  elseif selector == -1 and cx > 2 then --picking tool and not dirt/tilled
    if cx == 7 then
      stock_pile_selection()--placing on stockpile
    elseif dy == 4 then
      fruit_collection()--collecting the fruit/filling basket
    end 
	elseif (cx) == 2 and selector ~= -1 and selector ~= 20 and gold-plant_cost[math.floor(selector/10)] > -1 then--can plant on tilled earth
    set[ax][by][0] = selector
    set[ax][by][1] = plant_time[math.floor(selector/10)]
    gold = gold-plant_cost[math.floor(selector/10)]--gold isn't correct as each plant costs a different amount?
  end
end
  --
  
  if button == "l" then
    
    if mouse_startx > x-8 and mouse_startx < x+8 and mouse_starty > y-8 and mouse_starty < y+8 then
      
      if x < 90 then--on side part
        
        menu_selection(x,y)
        
      elseif seed_box then
        
      --seedbox stuff
        seed_selection(x,y)
        
      else-- selector action
        
        board_action(x,y,tile_width,tile_height)
        
      end
      
    end
    
  end  
end